import { ComponentOptionsMixin } from 'vue-demi';
import { ComponentProvideOptions } from 'vue-demi';
import { DefineComponent } from 'vue-demi';
import { Mode } from 'vanilla-jsoneditor';
import { Plugin as Plugin_2 } from 'vue-demi';
import { PropType as PropType_2 } from 'vue-demi';
import { PublicProps } from 'vue-demi';
import { RendererElement } from 'vue-demi';
import { RendererNode } from 'vue-demi';

declare const _default: SFCWithInstall<typeof JsonEditorVue>;
export default _default;

declare const JsonEditorVue: DefineComponent<globalThis.ExtractPropTypes<{
modelValue: object;
value: object;
} & {
mode: {
type: PropType_2<Mode>;
};
debounce: {
type: PropType_2<number>;
};
stringified: {
type: PropType_2<boolean>;
default: undefined;
};
} & {
mainMenuBar: {
type: PropType_2<boolean>;
default: undefined;
};
navigationBar: {
type: PropType_2<boolean>;
default: undefined;
};
statusBar: {
type: PropType_2<boolean>;
default: undefined;
};
askToFormat: {
type: PropType_2<boolean>;
default: undefined;
};
readOnly: {
type: PropType_2<boolean>;
default: undefined;
};
escapeControlCharacters: {
type: PropType_2<boolean>;
default: undefined;
};
escapeUnicodeCharacters: {
type: PropType_2<boolean>;
default: undefined;
};
flattenColumns: {
type: PropType_2<boolean>;
default: undefined;
};
}>, () => globalThis.VNode<RendererNode, RendererElement, {
[key: string]: any;
}>, {}, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {
[x: string]: (_payload: any) => boolean;
'update:mode': (_payload: Mode) => boolean;
}, string, PublicProps, Readonly<globalThis.ExtractPropTypes<{
modelValue: object;
value: object;
} & {
mode: {
type: PropType_2<Mode>;
};
debounce: {
type: PropType_2<number>;
};
stringified: {
type: PropType_2<boolean>;
default: undefined;
};
} & {
mainMenuBar: {
type: PropType_2<boolean>;
default: undefined;
};
navigationBar: {
type: PropType_2<boolean>;
default: undefined;
};
statusBar: {
type: PropType_2<boolean>;
default: undefined;
};
askToFormat: {
type: PropType_2<boolean>;
default: undefined;
};
readOnly: {
type: PropType_2<boolean>;
default: undefined;
};
escapeControlCharacters: {
type: PropType_2<boolean>;
default: undefined;
};
escapeUnicodeCharacters: {
type: PropType_2<boolean>;
default: undefined;
};
flattenColumns: {
type: PropType_2<boolean>;
default: undefined;
};
}>> & Readonly<{
[x: `on${Capitalize<string>}`]: ((_payload: any) => any) | undefined;
}>, {
mainMenuBar: boolean;
navigationBar: boolean;
statusBar: boolean;
askToFormat: boolean;
readOnly: boolean;
escapeControlCharacters: boolean;
escapeUnicodeCharacters: boolean;
flattenColumns: boolean;
stringified: boolean;
}, {}, {}, {}, string, ComponentProvideOptions, true, {}, any>;

declare type SFCWithInstall<T> = T & Plugin_2;

export { }

declare namespace _default {
    namespace head {
        let title: string;
        namespace htmlAttrs {
            let lang: string;
        }
        let meta: ({
            charset: string;
            name?: undefined;
            content?: undefined;
            hid?: undefined;
        } | {
            name: string;
            content: string;
            charset?: undefined;
            hid?: undefined;
        } | {
            hid: string;
            name: string;
            content: string;
            charset?: undefined;
        })[];
        let link: {
            rel: string;
            type: string;
            href: string;
        }[];
    }
    let css: never[];
    let plugins: never[];
    let components: boolean;
    let buildModules: string[];
    let modules: never[];
    namespace build {
        let transpile: string[];
        function extend(config: any): void;
    }
}

declare namespace _default {
    namespace head {
        let title: string;
        namespace htmlAttrs {
            let lang: string;
        }
        let meta: ({
            charset: string;
            name?: undefined;
            content?: undefined;
            hid?: undefined;
        } | {
            name: string;
            content: string;
            charset?: undefined;
            hid?: undefined;
        } | {
            hid: string;
            name: string;
            content: string;
            charset?: undefined;
        })[];
        let link: {
            rel: string;
            type: string;
            href: string;
        }[];
    }
    let css: never[];
    let plugins: never[];
    let components: boolean;
    let buildModules: string[];
    let modules: never[];
    namespace build {
        let transpile: string[];
        function extend(config: any): void;
    }
}
