import { Mode as en, JSONEditor as on } from "vanilla-jsoneditor";
import { isVue3 as Et, defineComponent as an, getCurrentInstance as un, ref as dt, watchEffect as cn, computed as Wt, onUnmounted as fn, onMounted as sn, watch as vt, unref as ln, h as pn } from "vue-demi";
const dn = /"(?:_|\\u0{2}5[Ff]){2}(?:p|\\u0{2}70)(?:r|\\u0{2}72)(?:o|\\u0{2}6[Ff])(?:t|\\u0{2}74)(?:o|\\u0{2}6[Ff])(?:_|\\u0{2}5[Ff]){2}"\s*:/, vn = /"(?:c|\\u0063)(?:o|\\u006[Ff])(?:n|\\u006[Ee])(?:s|\\u0073)(?:t|\\u0074)(?:r|\\u0072)(?:u|\\u0075)(?:c|\\u0063)(?:t|\\u0074)(?:o|\\u006[Ff])(?:r|\\u0072)"\s*:/, bn = /^\s*["[{]|^\s*-?\d{1,16}(\.\d{1,17})?([Ee][+-]?\d+)?\s*$/;
function yn(t, r) {
  if (t === "__proto__" || t === "constructor" && r && typeof r == "object" && "prototype" in r) {
    hn(t);
    return;
  }
  return r;
}
function hn(t) {
  console.warn(`[destr] Dropping "${t}" key to prevent prototype pollution.`);
}
function Z(t, r = {}) {
  if (typeof t != "string")
    return t;
  const n = t.trim();
  if (
    // eslint-disable-next-line unicorn/prefer-at
    t[0] === '"' && t.endsWith('"') && !t.includes("\\")
  )
    return n.slice(1, -1);
  if (n.length <= 9) {
    const e = n.toLowerCase();
    if (e === "true")
      return !0;
    if (e === "false")
      return !1;
    if (e === "undefined")
      return;
    if (e === "null")
      return null;
    if (e === "nan")
      return Number.NaN;
    if (e === "infinity")
      return Number.POSITIVE_INFINITY;
    if (e === "-infinity")
      return Number.NEGATIVE_INFINITY;
  }
  if (!bn.test(t)) {
    if (r.strict)
      throw new SyntaxError("[destr] Invalid JSON");
    return t;
  }
  try {
    if (dn.test(t) || vn.test(t)) {
      if (r.strict)
        throw new Error("[destr] Possible prototype pollution");
      return JSON.parse(t, yn);
    }
    return JSON.parse(t);
  } catch (e) {
    if (r.strict)
      throw e;
    return t;
  }
}
function jn(t, r = {}) {
  return Z(t, { ...r, strict: !0 });
}
var gn = typeof global == "object" && global && global.Object === Object && global, mn = typeof self == "object" && self && self.Object === Object && self, Er = gn || mn || Function("return this")(), et = Er.Symbol, Tr = Object.prototype, _n = Tr.hasOwnProperty, On = Tr.toString, W = et ? et.toStringTag : void 0;
function wn(t) {
  var r = _n.call(t, W), n = t[W];
  try {
    t[W] = void 0;
    var e = !0;
  } catch {
  }
  var i = On.call(t);
  return e && (r ? t[W] = n : delete t[W]), i;
}
var An = Object.prototype, xn = An.toString;
function Sn(t) {
  return xn.call(t);
}
var En = "[object Null]", Tn = "[object Undefined]", Vt = et ? et.toStringTag : void 0;
function In(t) {
  return t == null ? t === void 0 ? Tn : En : Vt && Vt in Object(t) ? wn(t) : Sn(t);
}
function Pn(t) {
  return t != null && typeof t == "object";
}
var Fn = "[object Symbol]";
function kn(t) {
  return typeof t == "symbol" || Pn(t) && In(t) == Fn;
}
var Cn = /\s/;
function zn(t) {
  for (var r = t.length; r-- && Cn.test(t.charAt(r)); )
    ;
  return r;
}
var Nn = /^\s+/;
function $n(t) {
  return t && t.slice(0, zn(t) + 1).replace(Nn, "");
}
function gt(t) {
  var r = typeof t;
  return t != null && (r == "object" || r == "function");
}
var Gt = NaN, Ln = /^[-+]0x[0-9a-f]+$/i, Bn = /^0b[01]+$/i, Mn = /^0o[0-7]+$/i, Un = parseInt;
function Jt(t) {
  if (typeof t == "number")
    return t;
  if (kn(t))
    return Gt;
  if (gt(t)) {
    var r = typeof t.valueOf == "function" ? t.valueOf() : t;
    t = gt(r) ? r + "" : r;
  }
  if (typeof t != "string")
    return t === 0 ? t : +t;
  t = $n(t);
  var n = Bn.test(t);
  return n || Mn.test(t) ? Un(t.slice(2), n ? 2 : 8) : Ln.test(t) ? Gt : +t;
}
var bt = function() {
  return Er.Date.now();
}, Dn = "Expected a function", Rn = Math.max, Wn = Math.min;
function Vn(t, r, n) {
  var e, i, o, a, u, c, f = 0, p = !1, d = !1, v = !0;
  if (typeof t != "function")
    throw new TypeError(Dn);
  r = Jt(r) || 0, gt(n) && (p = !!n.leading, d = "maxWait" in n, o = d ? Rn(Jt(n.maxWait) || 0, r) : o, v = "trailing" in n ? !!n.trailing : v);
  function h(_) {
    var C = e, R = i;
    return e = i = void 0, f = _, a = t.apply(R, C), a;
  }
  function y(_) {
    return f = _, u = setTimeout(b, r), p ? h(_) : a;
  }
  function s(_) {
    var C = _ - c, R = _ - f, Rt = r - C;
    return d ? Wn(Rt, o - R) : Rt;
  }
  function O(_) {
    var C = _ - c, R = _ - f;
    return c === void 0 || C >= r || C < 0 || d && R >= o;
  }
  function b() {
    var _ = bt();
    if (O(_))
      return l(_);
    u = setTimeout(b, s(_));
  }
  function l(_) {
    return u = void 0, v && e ? h(_) : (e = i = void 0, a);
  }
  function m() {
    u !== void 0 && clearTimeout(u), f = 0, e = c = i = u = void 0;
  }
  function A() {
    return u === void 0 ? a : l(bt());
  }
  function w() {
    var _ = bt(), C = O(_);
    if (e = arguments, i = this, c = _, C) {
      if (u === void 0)
        return y(c);
      if (d)
        return clearTimeout(u), u = setTimeout(b, r), h(c);
    }
    return u === void 0 && (u = setTimeout(b, r)), a;
  }
  return w.cancel = m, w.flush = A, w;
}
var Ir = typeof global == "object" && global && global.Object === Object && global, Gn = typeof self == "object" && self && self.Object === Object && self, I = Ir || Gn || Function("return this")(), E = I.Symbol, Pr = Object.prototype, Jn = Pr.hasOwnProperty, qn = Pr.toString, V = E ? E.toStringTag : void 0;
function Kn(t) {
  var r = Jn.call(t, V), n = t[V];
  try {
    t[V] = void 0;
    var e = !0;
  } catch {
  }
  var i = qn.call(t);
  return e && (r ? t[V] = n : delete t[V]), i;
}
var Hn = Object.prototype, Xn = Hn.toString;
function Qn(t) {
  return Xn.call(t);
}
var Yn = "[object Null]", Zn = "[object Undefined]", qt = E ? E.toStringTag : void 0;
function B(t) {
  return t == null ? t === void 0 ? Zn : Yn : qt && qt in Object(t) ? Kn(t) : Qn(t);
}
function T(t) {
  return t != null && typeof t == "object";
}
var te = "[object Symbol]";
function Tt(t) {
  return typeof t == "symbol" || T(t) && B(t) == te;
}
function re(t, r) {
  for (var n = -1, e = t == null ? 0 : t.length, i = Array(e); ++n < e; )
    i[n] = r(t[n], n, t);
  return i;
}
var x = Array.isArray, ne = 1 / 0, Kt = E ? E.prototype : void 0, Ht = Kt ? Kt.toString : void 0;
function Fr(t) {
  if (typeof t == "string")
    return t;
  if (x(t))
    return re(t, Fr) + "";
  if (Tt(t))
    return Ht ? Ht.call(t) : "";
  var r = t + "";
  return r == "0" && 1 / t == -ne ? "-0" : r;
}
function P(t) {
  var r = typeof t;
  return t != null && (r == "object" || r == "function");
}
function It(t) {
  return t;
}
var ee = "[object AsyncFunction]", oe = "[object Function]", ie = "[object GeneratorFunction]", ae = "[object Proxy]";
function Pt(t) {
  if (!P(t))
    return !1;
  var r = B(t);
  return r == oe || r == ie || r == ee || r == ae;
}
var yt = I["__core-js_shared__"], Xt = function() {
  var t = /[^.]+$/.exec(yt && yt.keys && yt.keys.IE_PROTO || "");
  return t ? "Symbol(src)_1." + t : "";
}();
function ue(t) {
  return !!Xt && Xt in t;
}
var ce = Function.prototype, fe = ce.toString;
function M(t) {
  if (t != null) {
    try {
      return fe.call(t);
    } catch {
    }
    try {
      return t + "";
    } catch {
    }
  }
  return "";
}
var se = /[\\^$.*+?()[\]{}|]/g, le = /^\[object .+?Constructor\]$/, pe = Function.prototype, de = Object.prototype, ve = pe.toString, be = de.hasOwnProperty, ye = RegExp(
  "^" + ve.call(be).replace(se, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"
);
function he(t) {
  if (!P(t) || ue(t))
    return !1;
  var r = Pt(t) ? ye : le;
  return r.test(M(t));
}
function je(t, r) {
  return t == null ? void 0 : t[r];
}
function U(t, r) {
  var n = je(t, r);
  return he(n) ? n : void 0;
}
var mt = U(I, "WeakMap"), Qt = Object.create, ge = /* @__PURE__ */ function() {
  function t() {
  }
  return function(r) {
    if (!P(r))
      return {};
    if (Qt)
      return Qt(r);
    t.prototype = r;
    var n = new t();
    return t.prototype = void 0, n;
  };
}();
function me(t, r, n) {
  switch (n.length) {
    case 0:
      return t.call(r);
    case 1:
      return t.call(r, n[0]);
    case 2:
      return t.call(r, n[0], n[1]);
    case 3:
      return t.call(r, n[0], n[1], n[2]);
  }
  return t.apply(r, n);
}
function _e(t, r) {
  var n = -1, e = t.length;
  for (r || (r = Array(e)); ++n < e; )
    r[n] = t[n];
  return r;
}
var Oe = 800, we = 16, Ae = Date.now;
function xe(t) {
  var r = 0, n = 0;
  return function() {
    var e = Ae(), i = we - (e - n);
    if (n = e, i > 0) {
      if (++r >= Oe)
        return arguments[0];
    } else
      r = 0;
    return t.apply(void 0, arguments);
  };
}
function Se(t) {
  return function() {
    return t;
  };
}
var ot = function() {
  try {
    var t = U(Object, "defineProperty");
    return t({}, "", {}), t;
  } catch {
  }
}(), Ee = ot ? function(t, r) {
  return ot(t, "toString", {
    configurable: !0,
    enumerable: !1,
    value: Se(r),
    writable: !0
  });
} : It;
const Te = Ee;
var Ie = xe(Te);
function Pe(t, r) {
  for (var n = -1, e = t == null ? 0 : t.length; ++n < e && r(t[n], n, t) !== !1; )
    ;
  return t;
}
var Fe = 9007199254740991, ke = /^(?:0|[1-9]\d*)$/;
function Ft(t, r) {
  var n = typeof t;
  return r = r ?? Fe, !!r && (n == "number" || n != "symbol" && ke.test(t)) && t > -1 && t % 1 == 0 && t < r;
}
function ct(t, r, n) {
  r == "__proto__" && ot ? ot(t, r, {
    configurable: !0,
    enumerable: !0,
    value: n,
    writable: !0
  }) : t[r] = n;
}
function Q(t, r) {
  return t === r || t !== t && r !== r;
}
var Ce = Object.prototype, ze = Ce.hasOwnProperty;
function kr(t, r, n) {
  var e = t[r];
  (!(ze.call(t, r) && Q(e, n)) || n === void 0 && !(r in t)) && ct(t, r, n);
}
function Cr(t, r, n, e) {
  var i = !n;
  n || (n = {});
  for (var o = -1, a = r.length; ++o < a; ) {
    var u = r[o], c = e ? e(n[u], t[u], u, n, t) : void 0;
    c === void 0 && (c = t[u]), i ? ct(n, u, c) : kr(n, u, c);
  }
  return n;
}
var Yt = Math.max;
function Ne(t, r, n) {
  return r = Yt(r === void 0 ? t.length - 1 : r, 0), function() {
    for (var e = arguments, i = -1, o = Yt(e.length - r, 0), a = Array(o); ++i < o; )
      a[i] = e[r + i];
    i = -1;
    for (var u = Array(r + 1); ++i < r; )
      u[i] = e[i];
    return u[r] = n(a), me(t, this, u);
  };
}
function $e(t, r) {
  return Ie(Ne(t, r, It), t + "");
}
var Le = 9007199254740991;
function kt(t) {
  return typeof t == "number" && t > -1 && t % 1 == 0 && t <= Le;
}
function ft(t) {
  return t != null && kt(t.length) && !Pt(t);
}
function Be(t, r, n) {
  if (!P(n))
    return !1;
  var e = typeof r;
  return (e == "number" ? ft(n) && Ft(r, n.length) : e == "string" && r in n) ? Q(n[r], t) : !1;
}
function zr(t) {
  return $e(function(r, n) {
    var e = -1, i = n.length, o = i > 1 ? n[i - 1] : void 0, a = i > 2 ? n[2] : void 0;
    for (o = t.length > 3 && typeof o == "function" ? (i--, o) : void 0, a && Be(n[0], n[1], a) && (o = i < 3 ? void 0 : o, i = 1), r = Object(r); ++e < i; ) {
      var u = n[e];
      u && t(r, u, e, o);
    }
    return r;
  });
}
var Me = Object.prototype;
function Ct(t) {
  var r = t && t.constructor, n = typeof r == "function" && r.prototype || Me;
  return t === n;
}
function Ue(t, r) {
  for (var n = -1, e = Array(t); ++n < t; )
    e[n] = r(n);
  return e;
}
var De = "[object Arguments]";
function Zt(t) {
  return T(t) && B(t) == De;
}
var Nr = Object.prototype, Re = Nr.hasOwnProperty, We = Nr.propertyIsEnumerable, it = Zt(/* @__PURE__ */ function() {
  return arguments;
}()) ? Zt : function(t) {
  return T(t) && Re.call(t, "callee") && !We.call(t, "callee");
};
function Ve() {
  return !1;
}
var $r = typeof exports == "object" && exports && !exports.nodeType && exports, tr = $r && typeof module == "object" && module && !module.nodeType && module, Ge = tr && tr.exports === $r, rr = Ge ? I.Buffer : void 0, Je = rr ? rr.isBuffer : void 0, q = Je || Ve, qe = "[object Arguments]", Ke = "[object Array]", He = "[object Boolean]", Xe = "[object Date]", Qe = "[object Error]", Ye = "[object Function]", Ze = "[object Map]", to = "[object Number]", ro = "[object Object]", no = "[object RegExp]", eo = "[object Set]", oo = "[object String]", io = "[object WeakMap]", ao = "[object ArrayBuffer]", uo = "[object DataView]", co = "[object Float32Array]", fo = "[object Float64Array]", so = "[object Int8Array]", lo = "[object Int16Array]", po = "[object Int32Array]", vo = "[object Uint8Array]", bo = "[object Uint8ClampedArray]", yo = "[object Uint16Array]", ho = "[object Uint32Array]", g = {};
g[co] = g[fo] = g[so] = g[lo] = g[po] = g[vo] = g[bo] = g[yo] = g[ho] = !0;
g[qe] = g[Ke] = g[ao] = g[He] = g[uo] = g[Xe] = g[Qe] = g[Ye] = g[Ze] = g[to] = g[ro] = g[no] = g[eo] = g[oo] = g[io] = !1;
function jo(t) {
  return T(t) && kt(t.length) && !!g[B(t)];
}
function zt(t) {
  return function(r) {
    return t(r);
  };
}
var Lr = typeof exports == "object" && exports && !exports.nodeType && exports, G = Lr && typeof module == "object" && module && !module.nodeType && module, go = G && G.exports === Lr, ht = go && Ir.process, D = function() {
  try {
    var t = G && G.require && G.require("util").types;
    return t || ht && ht.binding && ht.binding("util");
  } catch {
  }
}(), nr = D && D.isTypedArray, Nt = nr ? zt(nr) : jo, mo = Object.prototype, _o = mo.hasOwnProperty;
function Br(t, r) {
  var n = x(t), e = !n && it(t), i = !n && !e && q(t), o = !n && !e && !i && Nt(t), a = n || e || i || o, u = a ? Ue(t.length, String) : [], c = u.length;
  for (var f in t)
    (r || _o.call(t, f)) && !(a && // Safari 9 has enumerable `arguments.length` in strict mode.
    (f == "length" || // Node.js 0.10 has enumerable non-index properties on buffers.
    i && (f == "offset" || f == "parent") || // PhantomJS 2 has enumerable non-index properties on typed arrays.
    o && (f == "buffer" || f == "byteLength" || f == "byteOffset") || // Skip index properties.
    Ft(f, c))) && u.push(f);
  return u;
}
function Mr(t, r) {
  return function(n) {
    return t(r(n));
  };
}
var Oo = Mr(Object.keys, Object), wo = Object.prototype, Ao = wo.hasOwnProperty;
function xo(t) {
  if (!Ct(t))
    return Oo(t);
  var r = [];
  for (var n in Object(t))
    Ao.call(t, n) && n != "constructor" && r.push(n);
  return r;
}
function $t(t) {
  return ft(t) ? Br(t) : xo(t);
}
function So(t) {
  var r = [];
  if (t != null)
    for (var n in Object(t))
      r.push(n);
  return r;
}
var Eo = Object.prototype, To = Eo.hasOwnProperty;
function Io(t) {
  if (!P(t))
    return So(t);
  var r = Ct(t), n = [];
  for (var e in t)
    e == "constructor" && (r || !To.call(t, e)) || n.push(e);
  return n;
}
function Lt(t) {
  return ft(t) ? Br(t, !0) : Io(t);
}
var Po = zr(function(t, r, n, e) {
  Cr(r, Lt(r), t, e);
}), Fo = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/, ko = /^\w*$/;
function Bt(t, r) {
  if (x(t))
    return !1;
  var n = typeof t;
  return n == "number" || n == "symbol" || n == "boolean" || t == null || Tt(t) ? !0 : ko.test(t) || !Fo.test(t) || r != null && t in Object(r);
}
var K = U(Object, "create");
function Co() {
  this.__data__ = K ? K(null) : {}, this.size = 0;
}
function zo(t) {
  var r = this.has(t) && delete this.__data__[t];
  return this.size -= r ? 1 : 0, r;
}
var No = "__lodash_hash_undefined__", $o = Object.prototype, Lo = $o.hasOwnProperty;
function Bo(t) {
  var r = this.__data__;
  if (K) {
    var n = r[t];
    return n === No ? void 0 : n;
  }
  return Lo.call(r, t) ? r[t] : void 0;
}
var Mo = Object.prototype, Uo = Mo.hasOwnProperty;
function Do(t) {
  var r = this.__data__;
  return K ? r[t] !== void 0 : Uo.call(r, t);
}
var Ro = "__lodash_hash_undefined__";
function Wo(t, r) {
  var n = this.__data__;
  return this.size += this.has(t) ? 0 : 1, n[t] = K && r === void 0 ? Ro : r, this;
}
function L(t) {
  var r = -1, n = t == null ? 0 : t.length;
  for (this.clear(); ++r < n; ) {
    var e = t[r];
    this.set(e[0], e[1]);
  }
}
L.prototype.clear = Co;
L.prototype.delete = zo;
L.prototype.get = Bo;
L.prototype.has = Do;
L.prototype.set = Wo;
function Vo() {
  this.__data__ = [], this.size = 0;
}
function st(t, r) {
  for (var n = t.length; n--; )
    if (Q(t[n][0], r))
      return n;
  return -1;
}
var Go = Array.prototype, Jo = Go.splice;
function qo(t) {
  var r = this.__data__, n = st(r, t);
  if (n < 0)
    return !1;
  var e = r.length - 1;
  return n == e ? r.pop() : Jo.call(r, n, 1), --this.size, !0;
}
function Ko(t) {
  var r = this.__data__, n = st(r, t);
  return n < 0 ? void 0 : r[n][1];
}
function Ho(t) {
  return st(this.__data__, t) > -1;
}
function Xo(t, r) {
  var n = this.__data__, e = st(n, t);
  return e < 0 ? (++this.size, n.push([t, r])) : n[e][1] = r, this;
}
function F(t) {
  var r = -1, n = t == null ? 0 : t.length;
  for (this.clear(); ++r < n; ) {
    var e = t[r];
    this.set(e[0], e[1]);
  }
}
F.prototype.clear = Vo;
F.prototype.delete = qo;
F.prototype.get = Ko;
F.prototype.has = Ho;
F.prototype.set = Xo;
var H = U(I, "Map");
function Qo() {
  this.size = 0, this.__data__ = {
    hash: new L(),
    map: new (H || F)(),
    string: new L()
  };
}
function Yo(t) {
  var r = typeof t;
  return r == "string" || r == "number" || r == "symbol" || r == "boolean" ? t !== "__proto__" : t === null;
}
function lt(t, r) {
  var n = t.__data__;
  return Yo(r) ? n[typeof r == "string" ? "string" : "hash"] : n.map;
}
function Zo(t) {
  var r = lt(this, t).delete(t);
  return this.size -= r ? 1 : 0, r;
}
function ti(t) {
  return lt(this, t).get(t);
}
function ri(t) {
  return lt(this, t).has(t);
}
function ni(t, r) {
  var n = lt(this, t), e = n.size;
  return n.set(t, r), this.size += n.size == e ? 0 : 1, this;
}
function k(t) {
  var r = -1, n = t == null ? 0 : t.length;
  for (this.clear(); ++r < n; ) {
    var e = t[r];
    this.set(e[0], e[1]);
  }
}
k.prototype.clear = Qo;
k.prototype.delete = Zo;
k.prototype.get = ti;
k.prototype.has = ri;
k.prototype.set = ni;
var ei = "Expected a function";
function Mt(t, r) {
  if (typeof t != "function" || r != null && typeof r != "function")
    throw new TypeError(ei);
  var n = function() {
    var e = arguments, i = r ? r.apply(this, e) : e[0], o = n.cache;
    if (o.has(i))
      return o.get(i);
    var a = t.apply(this, e);
    return n.cache = o.set(i, a) || o, a;
  };
  return n.cache = new (Mt.Cache || k)(), n;
}
Mt.Cache = k;
var oi = 500;
function ii(t) {
  var r = Mt(t, function(e) {
    return n.size === oi && n.clear(), e;
  }), n = r.cache;
  return r;
}
var ai = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g, ui = /\\(\\)?/g, ci = ii(function(t) {
  var r = [];
  return t.charCodeAt(0) === 46 && r.push(""), t.replace(ai, function(n, e, i, o) {
    r.push(i ? o.replace(ui, "$1") : e || n);
  }), r;
});
function fi(t) {
  return t == null ? "" : Fr(t);
}
function Ur(t, r) {
  return x(t) ? t : Bt(t, r) ? [t] : ci(fi(t));
}
var si = 1 / 0;
function pt(t) {
  if (typeof t == "string" || Tt(t))
    return t;
  var r = t + "";
  return r == "0" && 1 / t == -si ? "-0" : r;
}
function Dr(t, r) {
  r = Ur(r, t);
  for (var n = 0, e = r.length; t != null && n < e; )
    t = t[pt(r[n++])];
  return n && n == e ? t : void 0;
}
function li(t, r, n) {
  var e = t == null ? void 0 : Dr(t, r);
  return e === void 0 ? n : e;
}
function pi(t, r) {
  for (var n = -1, e = r.length, i = t.length; ++n < e; )
    t[i + n] = r[n];
  return t;
}
var di = Mr(Object.getPrototypeOf, Object);
const Rr = di;
var vi = "[object Object]", bi = Function.prototype, yi = Object.prototype, Wr = bi.toString, hi = yi.hasOwnProperty, ji = Wr.call(Object);
function gi(t) {
  if (!T(t) || B(t) != vi)
    return !1;
  var r = Rr(t);
  if (r === null)
    return !0;
  var n = hi.call(r, "constructor") && r.constructor;
  return typeof n == "function" && n instanceof n && Wr.call(n) == ji;
}
function mi() {
  this.__data__ = new F(), this.size = 0;
}
function _i(t) {
  var r = this.__data__, n = r.delete(t);
  return this.size = r.size, n;
}
function Oi(t) {
  return this.__data__.get(t);
}
function wi(t) {
  return this.__data__.has(t);
}
var Ai = 200;
function xi(t, r) {
  var n = this.__data__;
  if (n instanceof F) {
    var e = n.__data__;
    if (!H || e.length < Ai - 1)
      return e.push([t, r]), this.size = ++n.size, this;
    n = this.__data__ = new k(e);
  }
  return n.set(t, r), this.size = n.size, this;
}
function S(t) {
  var r = this.__data__ = new F(t);
  this.size = r.size;
}
S.prototype.clear = mi;
S.prototype.delete = _i;
S.prototype.get = Oi;
S.prototype.has = wi;
S.prototype.set = xi;
var Vr = typeof exports == "object" && exports && !exports.nodeType && exports, er = Vr && typeof module == "object" && module && !module.nodeType && module, Si = er && er.exports === Vr, or = Si ? I.Buffer : void 0, ir = or ? or.allocUnsafe : void 0;
function Gr(t, r) {
  if (r)
    return t.slice();
  var n = t.length, e = ir ? ir(n) : new t.constructor(n);
  return t.copy(e), e;
}
function Ei(t, r) {
  for (var n = -1, e = t == null ? 0 : t.length, i = 0, o = []; ++n < e; ) {
    var a = t[n];
    r(a, n, t) && (o[i++] = a);
  }
  return o;
}
function Ti() {
  return [];
}
var Ii = Object.prototype, Pi = Ii.propertyIsEnumerable, ar = Object.getOwnPropertySymbols, Fi = ar ? function(t) {
  return t == null ? [] : (t = Object(t), Ei(ar(t), function(r) {
    return Pi.call(t, r);
  }));
} : Ti;
function ki(t, r, n) {
  var e = r(t);
  return x(t) ? e : pi(e, n(t));
}
function _t(t) {
  return ki(t, $t, Fi);
}
var Ot = U(I, "DataView"), wt = U(I, "Promise"), At = U(I, "Set"), ur = "[object Map]", Ci = "[object Object]", cr = "[object Promise]", fr = "[object Set]", sr = "[object WeakMap]", lr = "[object DataView]", zi = M(Ot), Ni = M(H), $i = M(wt), Li = M(At), Bi = M(mt), $ = B;
(Ot && $(new Ot(new ArrayBuffer(1))) != lr || H && $(new H()) != ur || wt && $(wt.resolve()) != cr || At && $(new At()) != fr || mt && $(new mt()) != sr) && ($ = function(t) {
  var r = B(t), n = r == Ci ? t.constructor : void 0, e = n ? M(n) : "";
  if (e)
    switch (e) {
      case zi:
        return lr;
      case Ni:
        return ur;
      case $i:
        return cr;
      case Li:
        return fr;
      case Bi:
        return sr;
    }
  return r;
});
const X = $;
var Mi = Object.prototype, Ui = Mi.hasOwnProperty;
function Di(t) {
  var r = t.length, n = new t.constructor(r);
  return r && typeof t[0] == "string" && Ui.call(t, "index") && (n.index = t.index, n.input = t.input), n;
}
var at = I.Uint8Array;
function Ut(t) {
  var r = new t.constructor(t.byteLength);
  return new at(r).set(new at(t)), r;
}
function Ri(t, r) {
  var n = Ut(t.buffer);
  return new t.constructor(n, t.byteOffset, t.byteLength);
}
var Wi = /\w*$/;
function Vi(t) {
  var r = new t.constructor(t.source, Wi.exec(t));
  return r.lastIndex = t.lastIndex, r;
}
var pr = E ? E.prototype : void 0, dr = pr ? pr.valueOf : void 0;
function Gi(t) {
  return dr ? Object(dr.call(t)) : {};
}
function Jr(t, r) {
  var n = r ? Ut(t.buffer) : t.buffer;
  return new t.constructor(n, t.byteOffset, t.length);
}
var Ji = "[object Boolean]", qi = "[object Date]", Ki = "[object Map]", Hi = "[object Number]", Xi = "[object RegExp]", Qi = "[object Set]", Yi = "[object String]", Zi = "[object Symbol]", ta = "[object ArrayBuffer]", ra = "[object DataView]", na = "[object Float32Array]", ea = "[object Float64Array]", oa = "[object Int8Array]", ia = "[object Int16Array]", aa = "[object Int32Array]", ua = "[object Uint8Array]", ca = "[object Uint8ClampedArray]", fa = "[object Uint16Array]", sa = "[object Uint32Array]";
function la(t, r, n) {
  var e = t.constructor;
  switch (r) {
    case ta:
      return Ut(t);
    case Ji:
    case qi:
      return new e(+t);
    case ra:
      return Ri(t);
    case na:
    case ea:
    case oa:
    case ia:
    case aa:
    case ua:
    case ca:
    case fa:
    case sa:
      return Jr(t, n);
    case Ki:
      return new e();
    case Hi:
    case Yi:
      return new e(t);
    case Xi:
      return Vi(t);
    case Qi:
      return new e();
    case Zi:
      return Gi(t);
  }
}
function qr(t) {
  return typeof t.constructor == "function" && !Ct(t) ? ge(Rr(t)) : {};
}
var pa = "[object Map]";
function da(t) {
  return T(t) && X(t) == pa;
}
var vr = D && D.isMap, va = vr ? zt(vr) : da, ba = "[object Set]";
function ya(t) {
  return T(t) && X(t) == ba;
}
var br = D && D.isSet, ha = br ? zt(br) : ya, ja = 1, Kr = "[object Arguments]", ga = "[object Array]", ma = "[object Boolean]", _a = "[object Date]", Oa = "[object Error]", Hr = "[object Function]", wa = "[object GeneratorFunction]", Aa = "[object Map]", xa = "[object Number]", Xr = "[object Object]", Sa = "[object RegExp]", Ea = "[object Set]", Ta = "[object String]", Ia = "[object Symbol]", Pa = "[object WeakMap]", Fa = "[object ArrayBuffer]", ka = "[object DataView]", Ca = "[object Float32Array]", za = "[object Float64Array]", Na = "[object Int8Array]", $a = "[object Int16Array]", La = "[object Int32Array]", Ba = "[object Uint8Array]", Ma = "[object Uint8ClampedArray]", Ua = "[object Uint16Array]", Da = "[object Uint32Array]", j = {};
j[Kr] = j[ga] = j[Fa] = j[ka] = j[ma] = j[_a] = j[Ca] = j[za] = j[Na] = j[$a] = j[La] = j[Aa] = j[xa] = j[Xr] = j[Sa] = j[Ea] = j[Ta] = j[Ia] = j[Ba] = j[Ma] = j[Ua] = j[Da] = !0;
j[Oa] = j[Hr] = j[Pa] = !1;
function tt(t, r, n, e, i, o) {
  var a, u = r & ja;
  if (a !== void 0)
    return a;
  if (!P(t))
    return t;
  var c = x(t);
  if (c)
    a = Di(t);
  else {
    var f = X(t), p = f == Hr || f == wa;
    if (q(t))
      return Gr(t, u);
    if (f == Xr || f == Kr || p && !i)
      a = p ? {} : qr(t);
    else {
      if (!j[f])
        return i ? t : {};
      a = la(t, f, u);
    }
  }
  o || (o = new S());
  var d = o.get(t);
  if (d)
    return d;
  o.set(t, a), ha(t) ? t.forEach(function(y) {
    a.add(tt(y, r, n, y, t, o));
  }) : va(t) && t.forEach(function(y, s) {
    a.set(s, tt(y, r, n, s, t, o));
  });
  var v = _t, h = c ? void 0 : v(t);
  return Pe(h || t, function(y, s) {
    h && (s = y, y = t[s]), kr(a, s, tt(y, r, n, s, t, o));
  }), a;
}
var Ra = 1, Wa = 4;
function Va(t) {
  return tt(t, Ra | Wa);
}
var Ga = "__lodash_hash_undefined__";
function Ja(t) {
  return this.__data__.set(t, Ga), this;
}
function qa(t) {
  return this.__data__.has(t);
}
function ut(t) {
  var r = -1, n = t == null ? 0 : t.length;
  for (this.__data__ = new k(); ++r < n; )
    this.add(t[r]);
}
ut.prototype.add = ut.prototype.push = Ja;
ut.prototype.has = qa;
function Ka(t, r) {
  for (var n = -1, e = t == null ? 0 : t.length; ++n < e; )
    if (r(t[n], n, t))
      return !0;
  return !1;
}
function Ha(t, r) {
  return t.has(r);
}
var Xa = 1, Qa = 2;
function Qr(t, r, n, e, i, o) {
  var a = n & Xa, u = t.length, c = r.length;
  if (u != c && !(a && c > u))
    return !1;
  var f = o.get(t), p = o.get(r);
  if (f && p)
    return f == r && p == t;
  var d = -1, v = !0, h = n & Qa ? new ut() : void 0;
  for (o.set(t, r), o.set(r, t); ++d < u; ) {
    var y = t[d], s = r[d];
    if (e)
      var O = a ? e(s, y, d, r, t, o) : e(y, s, d, t, r, o);
    if (O !== void 0) {
      if (O)
        continue;
      v = !1;
      break;
    }
    if (h) {
      if (!Ka(r, function(b, l) {
        if (!Ha(h, l) && (y === b || i(y, b, n, e, o)))
          return h.push(l);
      })) {
        v = !1;
        break;
      }
    } else if (!(y === s || i(y, s, n, e, o))) {
      v = !1;
      break;
    }
  }
  return o.delete(t), o.delete(r), v;
}
function Ya(t) {
  var r = -1, n = Array(t.size);
  return t.forEach(function(e, i) {
    n[++r] = [i, e];
  }), n;
}
function Za(t) {
  var r = -1, n = Array(t.size);
  return t.forEach(function(e) {
    n[++r] = e;
  }), n;
}
var tu = 1, ru = 2, nu = "[object Boolean]", eu = "[object Date]", ou = "[object Error]", iu = "[object Map]", au = "[object Number]", uu = "[object RegExp]", cu = "[object Set]", fu = "[object String]", su = "[object Symbol]", lu = "[object ArrayBuffer]", pu = "[object DataView]", yr = E ? E.prototype : void 0, jt = yr ? yr.valueOf : void 0;
function du(t, r, n, e, i, o, a) {
  switch (n) {
    case pu:
      if (t.byteLength != r.byteLength || t.byteOffset != r.byteOffset)
        return !1;
      t = t.buffer, r = r.buffer;
    case lu:
      return !(t.byteLength != r.byteLength || !o(new at(t), new at(r)));
    case nu:
    case eu:
    case au:
      return Q(+t, +r);
    case ou:
      return t.name == r.name && t.message == r.message;
    case uu:
    case fu:
      return t == r + "";
    case iu:
      var u = Ya;
    case cu:
      var c = e & tu;
      if (u || (u = Za), t.size != r.size && !c)
        return !1;
      var f = a.get(t);
      if (f)
        return f == r;
      e |= ru, a.set(t, r);
      var p = Qr(u(t), u(r), e, i, o, a);
      return a.delete(t), p;
    case su:
      if (jt)
        return jt.call(t) == jt.call(r);
  }
  return !1;
}
var vu = 1, bu = Object.prototype, yu = bu.hasOwnProperty;
function hu(t, r, n, e, i, o) {
  var a = n & vu, u = _t(t), c = u.length, f = _t(r), p = f.length;
  if (c != p && !a)
    return !1;
  for (var d = c; d--; ) {
    var v = u[d];
    if (!(a ? v in r : yu.call(r, v)))
      return !1;
  }
  var h = o.get(t), y = o.get(r);
  if (h && y)
    return h == r && y == t;
  var s = !0;
  o.set(t, r), o.set(r, t);
  for (var O = a; ++d < c; ) {
    v = u[d];
    var b = t[v], l = r[v];
    if (e)
      var m = a ? e(l, b, v, r, t, o) : e(b, l, v, t, r, o);
    if (!(m === void 0 ? b === l || i(b, l, n, e, o) : m)) {
      s = !1;
      break;
    }
    O || (O = v == "constructor");
  }
  if (s && !O) {
    var A = t.constructor, w = r.constructor;
    A != w && "constructor" in t && "constructor" in r && !(typeof A == "function" && A instanceof A && typeof w == "function" && w instanceof w) && (s = !1);
  }
  return o.delete(t), o.delete(r), s;
}
var ju = 1, hr = "[object Arguments]", jr = "[object Array]", Y = "[object Object]", gu = Object.prototype, gr = gu.hasOwnProperty;
function mu(t, r, n, e, i, o) {
  var a = x(t), u = x(r), c = a ? jr : X(t), f = u ? jr : X(r);
  c = c == hr ? Y : c, f = f == hr ? Y : f;
  var p = c == Y, d = f == Y, v = c == f;
  if (v && q(t)) {
    if (!q(r))
      return !1;
    a = !0, p = !1;
  }
  if (v && !p)
    return o || (o = new S()), a || Nt(t) ? Qr(t, r, n, e, i, o) : du(t, r, c, n, e, i, o);
  if (!(n & ju)) {
    var h = p && gr.call(t, "__wrapped__"), y = d && gr.call(r, "__wrapped__");
    if (h || y) {
      var s = h ? t.value() : t, O = y ? r.value() : r;
      return o || (o = new S()), i(s, O, n, e, o);
    }
  }
  return v ? (o || (o = new S()), hu(t, r, n, e, i, o)) : !1;
}
function Dt(t, r, n, e, i) {
  return t === r ? !0 : t == null || r == null || !T(t) && !T(r) ? t !== t && r !== r : mu(t, r, n, e, Dt, i);
}
var _u = 1, Ou = 2;
function wu(t, r, n, e) {
  var i = n.length, o = i;
  if (t == null)
    return !o;
  for (t = Object(t); i--; ) {
    var a = n[i];
    if (a[2] ? a[1] !== t[a[0]] : !(a[0] in t))
      return !1;
  }
  for (; ++i < o; ) {
    a = n[i];
    var u = a[0], c = t[u], f = a[1];
    if (a[2]) {
      if (c === void 0 && !(u in t))
        return !1;
    } else {
      var p = new S(), d;
      if (!(d === void 0 ? Dt(f, c, _u | Ou, e, p) : d))
        return !1;
    }
  }
  return !0;
}
function Yr(t) {
  return t === t && !P(t);
}
function Au(t) {
  for (var r = $t(t), n = r.length; n--; ) {
    var e = r[n], i = t[e];
    r[n] = [e, i, Yr(i)];
  }
  return r;
}
function Zr(t, r) {
  return function(n) {
    return n == null ? !1 : n[t] === r && (r !== void 0 || t in Object(n));
  };
}
function xu(t) {
  var r = Au(t);
  return r.length == 1 && r[0][2] ? Zr(r[0][0], r[0][1]) : function(n) {
    return n === t || wu(n, t, r);
  };
}
function Su(t, r) {
  return t != null && r in Object(t);
}
function Eu(t, r, n) {
  r = Ur(r, t);
  for (var e = -1, i = r.length, o = !1; ++e < i; ) {
    var a = pt(r[e]);
    if (!(o = t != null && n(t, a)))
      break;
    t = t[a];
  }
  return o || ++e != i ? o : (i = t == null ? 0 : t.length, !!i && kt(i) && Ft(a, i) && (x(t) || it(t)));
}
function Tu(t, r) {
  return t != null && Eu(t, r, Su);
}
var Iu = 1, Pu = 2;
function Fu(t, r) {
  return Bt(t) && Yr(r) ? Zr(pt(t), r) : function(n) {
    var e = li(n, t);
    return e === void 0 && e === r ? Tu(n, t) : Dt(r, e, Iu | Pu);
  };
}
function ku(t) {
  return function(r) {
    return r == null ? void 0 : r[t];
  };
}
function Cu(t) {
  return function(r) {
    return Dr(r, t);
  };
}
function zu(t) {
  return Bt(t) ? ku(pt(t)) : Cu(t);
}
function Nu(t) {
  return typeof t == "function" ? t : t == null ? It : typeof t == "object" ? x(t) ? Fu(t[0], t[1]) : xu(t) : zu(t);
}
function $u(t) {
  return function(r, n, e) {
    for (var i = -1, o = Object(r), a = e(r), u = a.length; u--; ) {
      var c = a[++i];
      if (n(o[c], c, o) === !1)
        break;
    }
    return r;
  };
}
var tn = $u();
function Lu(t, r) {
  return t && tn(t, r, $t);
}
function xt(t, r, n) {
  (n !== void 0 && !Q(t[r], n) || n === void 0 && !(r in t)) && ct(t, r, n);
}
function Bu(t) {
  return T(t) && ft(t);
}
function St(t, r) {
  if (!(r === "constructor" && typeof t[r] == "function") && r != "__proto__")
    return t[r];
}
function Mu(t) {
  return Cr(t, Lt(t));
}
function Uu(t, r, n, e, i, o, a) {
  var u = St(t, n), c = St(r, n), f = a.get(c);
  if (f) {
    xt(t, n, f);
    return;
  }
  var p = o ? o(u, c, n + "", t, r, a) : void 0, d = p === void 0;
  if (d) {
    var v = x(c), h = !v && q(c), y = !v && !h && Nt(c);
    p = c, v || h || y ? x(u) ? p = u : Bu(u) ? p = _e(u) : h ? (d = !1, p = Gr(c, !0)) : y ? (d = !1, p = Jr(c, !0)) : p = [] : gi(c) || it(c) ? (p = u, it(u) ? p = Mu(u) : (!P(u) || Pt(u)) && (p = qr(c))) : d = !1;
  }
  d && (a.set(c, p), i(p, c, e, o, a), a.delete(c)), xt(t, n, p);
}
function rn(t, r, n, e, i) {
  t !== r && tn(r, function(o, a) {
    if (i || (i = new S()), P(o))
      Uu(t, r, a, n, rn, e, i);
    else {
      var u = e ? e(St(t, a), o, a + "", t, r, i) : void 0;
      u === void 0 && (u = o), xt(t, a, u);
    }
  }, Lt);
}
var Du = zr(function(t, r, n, e) {
  rn(t, r, n, e);
});
function Ru(t, r) {
  var n = {};
  return r = Nu(r), Lu(t, function(e, i, o) {
    ct(n, r(e, i, o), e);
  }), n;
}
const Wu = new RegExp("([\\p{Ll}\\d])(\\p{Lu})", "gu"), Vu = new RegExp("(\\p{Lu})([\\p{Lu}][\\p{Ll}])", "gu"), Gu = new RegExp("(\\d)\\p{Ll}|(\\p{L})\\d", "u"), Ju = /[^\p{L}\d]+/giu, mr = "$1\0$2", _r = "";
function nn(t) {
  let r = t.trim();
  r = r.replace(Wu, mr).replace(Vu, mr), r = r.replace(Ju, "\0");
  let n = 0, e = r.length;
  for (; r.charAt(n) === "\0"; )
    n++;
  if (n === e)
    return [];
  for (; r.charAt(e - 1) === "\0"; )
    e--;
  return r.slice(n, e).split(/\0/g);
}
function qu(t) {
  const r = nn(t);
  for (let n = 0; n < r.length; n++) {
    const e = r[n], i = Gu.exec(e);
    if (i) {
      const o = i.index + (i[1] ?? i[2]).length;
      r.splice(n, 1, e.slice(0, o), e.slice(o));
    }
  }
  return r;
}
function Ku(t, r) {
  const [n, e, i] = Yu(t, r), o = Hu(void 0), a = Xu(void 0), u = Qu(o, a);
  return n + e.map((c, f) => f === 0 ? o(c) : u(c, f)).join("") + i;
}
function Hu(t) {
  return (r) => r.toLocaleLowerCase(t);
}
function Xu(t) {
  return (r) => r.toLocaleUpperCase(t);
}
function Qu(t, r) {
  return (n, e) => {
    const i = n[0];
    return (e > 0 && i >= "0" && i <= "9" ? "_" + i : r(i)) + t(n.slice(1));
  };
}
function Yu(t, r = {}) {
  const n = r.split ?? (r.separateNumbers ? qu : nn), e = r.prefixCharacters ?? _r, i = r.suffixCharacters ?? _r;
  let o = 0, a = t.length;
  for (; o < t.length; ) {
    const u = t.charAt(o);
    if (!e.includes(u))
      break;
    o++;
  }
  for (; a > o; ) {
    const u = a - 1, c = t.charAt(u);
    if (!i.includes(c))
      break;
    a = u;
  }
  return [
    t.slice(0, o),
    n(t.slice(o, a)),
    t.slice(a)
  ];
}
const J = (t) => /.+-.+/.test(t) ? Ku(t) : t, Zu = (t) => Object.prototype.toString.call(t).slice(8, -1) === "Object";
function tc(t, r) {
  const n = /* @__PURE__ */ Object.create(null), e = t.split(",");
  for (let i = 0; i < e.length; i++)
    n[e[i]] = !0;
  return (i) => !!n[i];
}
const rc = /* @__PURE__ */ tc("String,Number,Boolean,Function,Symbol,BigInt");
function nc(t) {
  const r = t == null ? void 0 : t.toString().match(/^\s*function (\w+)/);
  return r ? r[1] : t === null ? "null" : "";
}
function ec(t, r) {
  let n;
  const e = nc(r);
  if (rc(e)) {
    const i = typeof t;
    n = i === e.toLowerCase(), !n && i === "object" && (n = t instanceof r);
  } else
    e === "Object" ? n = P(t) : e === "Array" ? n = Array.isArray(t) : e === "null" ? n = t === null : n = t instanceof r;
  return {
    valid: n,
    expectedType: e
  };
}
function oc({
  prop: t,
  type: r,
  validator: n
}) {
  if (![void 0, null].includes(t) && r) {
    let e = !1;
    const i = Array.isArray(r) ? r : [r], o = [];
    for (let a = 0; a < i.length && !e; a++) {
      const { valid: u, expectedType: c } = ec(t, i[a]);
      o.push(c || ""), e = u;
    }
    if (!e)
      throw new TypeError(
        `Invalid prop: type check failed, expecting [${o.join(
          ", "
        )}], receiving: ${t}`
      );
  }
  if (n && !n(t))
    throw new Error(`Invalid prop: validator check failed, receiving: ${t}`);
}
function ic(t, {
  mergeObject: r,
  mergeFunction: n
}) {
  const e = [];
  for (let o = t.length - 1; o >= 0; o--)
    e.push(t[o]);
  const i = n ? (o, a) => typeof o == "function" && typeof a == "function" ? n(a, o) : void 0 : void 0;
  return r === "deep" ? Du(...e, i) : Po(...e, i);
}
function ac(t, {
  mergeFunction: r
}) {
  return t.reduce(r, () => {
  });
}
function N(t, r = {}) {
  const {
    type: n,
    default: e,
    defaultIsDynamic: i = !1,
    required: o = !1,
    validator: a,
    camelizeObjectKeys: u = !1,
    mergeObjectApplyOnlyToDefault: c = !1,
    mergeFunctionApplyOnlyToDefault: f = !0
  } = r;
  let { mergeObject: p = "deep", mergeFunction: d = !1 } = r;
  const v = [];
  let h, y = !1, s = !1;
  const O = (b) => {
    if (b !== void 0) {
      oc({ type: n, prop: b, validator: a });
      const l = Zu(b), m = typeof b == "function";
      return y = l, s = m, l ? (b = Va(b), u ? Ru(b, (A, w) => J(w)) : b) : b;
    }
  };
  for (const b of t)
    v.push(O(b));
  if (!i)
    v.push(O(e));
  else if (typeof e != "function")
    throw new TypeError(
      `Invalid option: options.default should be Function when options.defaultIsDynamic enabled, receiving: ${e}`
    );
  y || (p = !1, s || (d = !1));
  for (let b = 0; b < v.length; b++) {
    const l = v[b];
    if (l !== void 0) {
      b === v.length - 1 ? h = l : p ? h = ic(
        c ? [l, e] : v,
        {
          mergeObject: p,
          mergeFunction: d
        }
      ) : d ? h = ac(
        f ? [l, e] : v,
        {
          mergeFunction: d
        }
      ) : h = l;
      break;
    }
  }
  if (o && [void 0, null].includes(h))
    throw new Error("Missing required prop");
  return i ? N(t, {
    ...r,
    default: e(h),
    defaultIsDynamic: !1
  }) : h;
}
function Or(t) {
  const r = Array.from(J(t));
  return r[0] = r[0].toUpperCase(), r.unshift("o", "n"), r.join("");
}
function uc(t, {
  props: r = [],
  camelizePropNames: n = !1
} = {}) {
  const e = {
    props: {},
    attrs: {},
    listeners: {},
    hooks: {},
    slots: {}
  };
  let i;
  if (Array.isArray(r))
    i = n ? r.map((o) => J(o)) : r;
  else if (n) {
    i = [];
    for (const o in r)
      i.push(J(o));
  } else
    i = Object.keys(r);
  for (const o in t)
    if (o.startsWith("@")) {
      const a = o.substring(1);
      if (Et)
        if (a.startsWith("vue:"))
          e.hooks[Or(a.replace("vue:", "vnode-"))] = t[o];
        else {
          if (a.startsWith("vnode"))
            throw new Error("@vnode-* hooks are no longer supported. Use the vue: prefix instead. For example, @vnode-mounted should be changed to @vue:mounted. @vnode-* hooks support has been removed in Vue 3.4.");
          e.listeners[Or(a)] = t[o];
        }
      else
        a.startsWith("hook:") ? e.hooks[a] = t[o] : e.listeners[a] = t[o];
    } else if (o.startsWith("#")) {
      const a = o.substring(1);
      a && (e.slots[a] = t[o]);
    } else {
      const a = n ? J(o) : o;
      i.includes(a) ? e.props[a] = t[o] : e.attrs[o] = t[o];
    }
  return e;
}
const wr = "JsonEditorVue", z = {}, Ar = {}, rt = Et ? "modelValue" : "value", xr = Et ? "update:modelValue" : "input", nt = [
  "mainMenuBar",
  "navigationBar",
  "statusBar",
  "askToFormat",
  "readOnly",
  "escapeControlCharacters",
  "escapeUnicodeCharacters",
  "flattenColumns"
], Sr = {
  [rt]: {},
  mode: {
    type: String
  },
  debounce: {
    type: Number
  },
  stringified: {
    type: Boolean,
    default: void 0
  },
  ...Object.fromEntries(
    nt.map((t) => [
      t,
      {
        type: Boolean,
        default: void 0
      }
    ])
  )
}, sc = an({
  name: wr,
  install(t, r) {
    const n = uc(r || {}, { props: Sr });
    Object.assign(z, n.props), Object.assign(Ar, n.attrs), t.component(wr, this);
  },
  props: Sr,
  emits: {
    [xr](t) {
      return !0;
    },
    "update:mode": function(t) {
      return !0;
    }
  },
  setup(t, { attrs: r, emit: n, expose: e }) {
    var y;
    const i = (y = un()) == null ? void 0 : y.proxy, o = dt(), a = dt(!1), u = dt();
    cn(() => {
      var s;
      u.value = N([t.mode, z.mode], {
        type: String
      }), (s = o.value) == null || s.updateProps({
        mode: u.value || en.tree
      });
    });
    const c = (s) => {
      n("update:mode", s);
    };
    z.mode !== void 0 && t.mode === void 0 && c(z.mode);
    const f = Wt(() => N([t.debounce, z.debounce, 100], {
      type: Number
    })), p = Wt(() => N([t.stringified, z.stringified, !0], {
      type: Boolean
    }));
    let d = Z;
    const v = Vn((s) => {
      a.value = !0, !p.value && s.text && (o.value && !o.value.validate() && (s.json = d(s.text)), s.text = void 0), n(
        xr,
        s.text === void 0 ? s.json : s.text
      );
    }, f.value), h = (s, O) => (...b) => {
      s(...b), O(...b);
    };
    return e == null || e({ jsonEditor: o }), fn(() => {
      var s;
      (s = o.value) == null || s.destroy();
    }), sn(() => {
      const s = N([t[rt], z[rt]]), O = Object.fromEntries(
        Array.from(nt, (l) => [l, N([t[l], z[l]])]).filter(
          ([, l]) => l !== void 0
        )
      ), b = N(
        [
          O,
          r,
          Ar
        ],
        {
          camelizeObjectKeys: !0,
          defaultIsDynamic: !0,
          default: (l) => {
            var m;
            return d = ((m = l.parser) == null ? void 0 : m.parse) || Z, {
              onChange: v,
              onChangeMode: c,
              mode: u.value,
              // Can not just pass one of parse and stringify
              parser: {
                // SafeDestr is used by default so that it will not affect the result of jsonEditor.value.validate()
                // When stringified is disabled, destr is used by default for better performance (destr is only called when JSON is valid)
                parse: jn,
                stringify: JSON.stringify
              },
              ...s !== void 0 && {
                content: {
                  [typeof s == "string" && u.value === "text" && p.value ? "text" : "json"]: s
                }
              }
            };
          },
          mergeFunction: h,
          mergeObject: "shallow",
          type: Object
        }
      );
      o.value = new on({
        target: i == null ? void 0 : i.$refs.jsonEditorRef,
        props: b
      }), vt(
        () => t[rt],
        (l) => {
          if (a.value) {
            a.value = !1;
            return;
          }
          o.value && o.value.set(
            [void 0, ""].includes(l) ? {
              text: ""
            } : {
              [typeof l == "string" && u.value === "text" && p.value ? "text" : "json"]: l
            }
          );
        },
        {
          deep: !0
        }
      ), vt(
        () => Array.from(nt, (l) => t[l]),
        (l) => {
          var m;
          (m = o.value) == null || m.updateProps(
            Object.fromEntries(Array.from(l, (A, w) => [nt[w], A]).filter(([, A]) => A !== void 0))
          );
        }
      ), vt(
        () => r,
        (l) => {
          var A, w;
          const m = {};
          (l.onChange || l["on-change"]) && (m.onChange = v), (l.onChangeMode || l["on-change-mode"]) && (m.onChangeMode = c), d = ((A = l.parser) == null ? void 0 : A.parse) || Z, (w = o.value) == null || w.updateProps(
            Object.getOwnPropertyNames(m).length > 0 ? N([l, m], {
              camelizeObjectKeys: !0,
              mergeFunction: h,
              mergeObject: "shallow",
              type: Object
            }) : l
          );
        },
        {
          deep: !0
        }
      ), e || (e = (l) => {
        for (const m in l)
          i[m] = ln(l[m]);
      }, e({ jsonEditor: o }));
    }), () => pn("div", { ref: "jsonEditorRef" });
  }
});
export {
  sc as default
};
//# sourceMappingURL=json-editor-vue.mjs.map
